let i0  =     160,
    i1  = i0 + 20;

let j0 = 70;

let fs = 40,
    th = 48,
    bpx= 14,
    bpy=  5,
    gap=880;

let arr   = '#222',
    lines = [arr,'#376149'],
    cbox  = [['#333'   ,'#f3efec'],
             [lines[1] ,'#e4f4fb']];
function testColor(i) {
    let c = d3.hsl(d3.interpolatePlasma(i/6));
    return [
        {l:c.l*0.4, s:c.s*0.5},
        {l:0.99 - (1-c.l)/5}
    ].map(o=>c.copy(o));
}

let svg = d3.select('svg.center');
svg.append('defs').selectAll().data(lines).enter()
    .append('marker').attrs({
        viewBox:'0 0 7 5', markerWidth:5.5, markerHeight:5,
        orient:'auto', refX:4.2, refY:2.5, fill:c=>c,
        id:(_,i)=>'arrow'+i
    })
    .append('path').attr('d','M0 0L7 2.5L0 5');

let cases = [
        ['Left argument?'       , 'Windowed reduction'    ],
        ['Rank 0?'              , 'Return argument'       ],
        ['Three-axis representation (and check for trivial cases)', null],
        ['Not a scalar dyadic?' , ', ,[⎕IO] ⊣\n⍪ ⍪[⎕IO] ⊢'],
        ['Boolean argument?'    , '+-×⌈⌊*|!\n∨∧⍱⍲<≤=≥>≠'  ],
        ['Integer/double?'      , '+-×⌈⌊'                 ]
    ].map(r=>[r[0],r[1]?r[1].split('\n'):[]]);

let s = 0;
let hs = cases.map(d => {let l=d[1].length, h=l?l+0.92:3, r=s+h/2; s+=h; return th*r;});

svg.append('line')
    .attrs({
        x1:i1, x2:i1, y1:20, y2:hs[5]+3.5*th,
        stroke:arr, 'stroke-width':6, 'marker-end':'url(#arrow0)'
    });

let highlight = svg.append('rect')
    .attrs({
        x:i0+gap-180,width:360, y:hs[4]-4,height:hs[5]-hs[3]-12,
        stroke:'#e6d33c', fill:'#fef9d3', 'stroke-width':2,
        opacity:0
    });

let boxes = svg.selectAll().data(cases).enter()
    .append('g').attr('transform',(_,i)=>'translate(0,'+(j0+hs[i])+')')
    .attr('stroke-width',1.5);

let spec = boxes.filter(d=>d[1].length);
let arrow = spec.append('line').datum((_,i)=>+(i>=2))
    .attr('stroke-width', 6)
    .attr('marker-end', c=>'url(#arrow'+c+')')
    .attrs({x1:i0, x2:i0+500, y1:0, y2:0, stroke:c=>lines[c]});
spec.filter((_,i)=>i>=2)
    .append('text')
    .attrs({x:i0+gap*5/8, y:-8, 'font-size':36, fill:lines[1]})
    .text('try');

let box = (x,ys,h,c) => ({
        x:x-bpx, y:-ys/2-bpy, height:h*ys+2*bpy, rx:4, stroke:c[0], fill:c[1]
    });
let r0 = boxes.append('rect')
    .attrs((_,i) => box(i0, th+16*(i==2), 1, testColor(i)));
let w0 = boxes.append('text')
    .attrs({x:i0, y:fs/3, 'font-size':fs})
    .text(d=>d[0])
    .nodes().map(n=>n.getBoundingClientRect().width);
r0.attr('width', (_,i)=>2*bpx+w0[i]);

spec = spec.append('g')
    .attr('transform', t=>'translate('+gap+','+th*(1-t[1].length)/2+')')
    .attr('font-family', (_,i)=>i<2?null:'monospace');
let r1 = spec.append('rect')
    .attrs((t,i) => box(0, th, t[1].length, cbox[+(i>=2)]))
    .attr('stroke-dasharray',(_,i)=>i>=2?'7 3':null);
spec.selectAll().data(d=>d[1]).enter()
    .append('text')
    .attr('text-anchor', 'middle')
    .attrs((_,i)=>({x:i0, y:fs/3+th*i, 'font-size':fs}))
    .text(t=>t);
let w1 = spec.nodes().map(n=>n.getBoundingClientRect().width);
r1.attrs((_,i)=>{let w=w1[i]; return {x:i0-w/2-bpx,width:w+2*bpx};});

arrow.attr('x2', (_,i)=>i0+gap-w1[i]/2-16-bpx);

document.onclick = function () {
    highlight.transition().duration(1000).attr('opacity',1);
}
