let h =  110,
    w =  186,
    W = 1400;

let xs =    100,
    x0 = xs+300,
    x1 = x0+160,
    x4 = xs+W,
    x3 = x4-196,
    x2 = x3-140;

let csh = '#222',
    clab= '#333944',
    carr= '#486956',
    ctyp= '#466';

let svg = d3.select('svg.center'),
    defs= svg.append('defs');
defs.append('linearGradient').attr('id', 'fade')
    .selectAll().data([0,0.02,0.98,1]).enter().append('stop')
    .attrs((o,i)=>({'stop-color': 1<=i&&i<=2?'white':'black', offset:o}));
defs.append('mask').attr('id','mask')
    .append('rect').attrs({x:xs,y:0,width:W,height:340,fill:'url(#fade)'});
defs.append('marker').attrs({
        viewBox:'0 0 7 5', markerWidth:12, markerHeight:6,
        orient:'auto', refX:4.2, refY:2.5, fill:carr,
        id:'arrow'
    })
    .append('path').attr('d','M0 0L7 2.5L0 5');


let y = i => (i+1/2)*h+6;

let rowind = d3.range(3);

let color = rowind.map(i =>
        (c=>c.copy({l:1-(1-c.l)/2.3}))
            (d3.hsl(d3.interpolatePlasma(0.4+0.25*i)))
    ),
    blend = color.slice();
for (let i=blend.length-1; i--; ) {
    blend[i] = d3.interpolateCubehelix.gamma(0.8)(blend[i+1],blend[i])(1/(blend.length-i));
}

let curve = ((c,dx)=>'c'+[c,0,dx-c,-h,dx,-h].join(' '))(40,w-40);
let back = svg.append('g')
    .attr('stroke','none')
    .attr('mask','url(#mask)')
    .selectAll().data(rowind).enter();
back.append('rect')
    .attrs(i => ({
        fill:color[i],
        x:xs, width:W, y:y(i-1/2), height:h
    }));
back.filter(i=>i<2)
    .append('path')
    .attrs(i => ({
        fill:blend[i],
        d:'M'+(x2-240-i*w)+' '+y(i+1/2)+curve+'H'+(xs+W)+'v'+h+'Z'
    }));

let g = svg.append('g');

let text = (x,l,t,a) => {
    let fs = [80,50][l];
    return g.selectAll().data(t).enter()
        .append('text').text(t=>t)
        .attrs({x:x, y:(_,i)=>y(i)+fs/3, 'text-anchor':a,
                'font-size':fs, fill:[csh,clab][l]});
}

let shape = [5,20,7];
let prod = shape.slice();
for (let i=prod.length-1; i--; ) { prod[i] *= prod[i+1]; }

text(x0, 1, ['leading','reduction','trailing'], 'end');
text(x1, 0, shape, 'end');
let cw = text((_,i)=>x2-i*w, 0, prod, 'middle')
    .nodes().map(n=>n.getBoundingClientRect().width);
text(x3, 1, ['array','cell','row'], null);

let garr = g.append('g')
    .attrs({
        'stroke-width':3, stroke:carr, 'marker-end':'url(#arrow)',
        opacity:0.66
    });
garr.selectAll().data(rowind).enter()
    .append('line')
    .attrs({ x1:x1+12, x2:i=>x2-20-i*w-cw[i]/2, y1:y, y2:y });
garr.selectAll().data(rowind.slice(0,-1).map(i=>(cw[i+1]-cw[i])/4)).enter()
    .append('line')
    .attrs((mid,i) => ({
        x1:x2-(i+1)*w+mid+60, y1:y(i+0.65),
        x2:x2- i   *w+mid-60, y2:y(i+0.35)
    }));
let ex = (p,r) => [1,-1, -2,2, 0,-2, 2,2]
    .map((d,i)=>'M l m l '.charAt(i)+(d*r+(p[i]||0))).join('');
garr.selectAll().data(rowind.slice(0,-1)).enter()
    .append('path')
    .attrs((mid,i) => ({
        d:ex([x2-i*w-5*mid-140,y(i+0.4)-12-mid], 12),
        'stroke-width':3.5, 'marker-end':'none'
    }));

g.selectAll().data(['AXES','CELLS']).enter().append('text')
    .attrs((_,i) => {
        let s = i?1:-1;
        return {
            transform:'rotate('+s*90+')', 'text-anchor':'middle',
            x:s*(1.5*h+4), y:-s*[xs,x4][i]-16,
            fill:ctyp, 'font-size':70, 'font-weight':300
        };
    })
    .text(t=>t);
