let n = 8,
    logn = Math.log2(n);

let w = 80,
    y0= 20,
    H = 190;

const ftext='#522866', fback='#f6f7d5', fbord='#35273b',
      dtext='#541e18', dback='#ffdfdb', dbord='#17100f';

let sequential = (() => {
    let pts = d3.range(n-1).map(i=>[i*w+(n-i)*(w/6),H*i/n]),
        ptse= pts.concat([[(n-1)*w,H]]),
        lines = d3.merge(pts.map((p,i)=>[[[i*w,H],p],[p,ptse[i+1]]]));
    return { pts:pts, lines:lines };
})();

let twowise = (() => {
    let pts = d3.range(logn+1).map(e=>{
            let h = (e/logn)*H,
                l = Math.pow(2,e);
            return d3.range(l).map(i=>[w*((i+1/2)*n/l-1/2),h]);
        }),
        ptsm= d3.merge(pts),
        lines = ptsm.slice(1).map((p,i)=>[ptsm[Math.floor(i/2)],p]);
    return { pts:d3.merge(pts.slice(0,logn)), lines:lines };
})();

let vector = (() => {
    let pts = d3.range(logn+1).map(e=>{
            let h = (Math.pow(2,e/2)-1)/(Math.pow(2,logn/2)-1)*H,
                l = Math.pow(2,e);
            return d3.range(l).map(i=>[w*(i+(n-l)/2),h]);
        }),
        lines = d3.merge(pts.slice(1).map((qs,j)=>{
            let ps = pts[j];
            return qs.map((q,i)=>[ps[i%ps.length],q]);
        }));
    return { pts:d3.merge(pts.slice(0,logn)), lines:lines };
})();

let svg = d3.selectAll('.tree').data([twowise,vector]);

let trees = svg.selectAll().data(tr=>[sequential,tr]).enter()
    .append('g').attr('transform',(_,j)=>'translate('+w*(2+11*j)+','+y0+')')
    .attrs({'text-anchor':'middle', 'font-size':33, 'font-family':'monospace'});
trees.selectAll().data(tr=>tr.lines).enter()
    .append('line')
    .attrs({'stroke-width':2, stroke:fbord})
    .attrs(l=>({x1:l[0][0],x2:l[1][0],y1:l[0][1],y2:l[1][1]}));
let op = trees.selectAll().data(tr=>tr.pts).enter();
op.append('circle').attrs(p=>({cx:p[0],cy:p[1],r:18,fill:fback,'stroke-width':1.5,stroke:fbord}));
let ex = r => p => [1,-1, -2,2, 0,-2, 2,2]
    .map((d,i)=>'M l m l '.charAt(i)+(d*r+(p[i]||0))).join('');
op.append('path').attrs({d:ex(7),fill:'none','stroke-width':3,stroke:ftext});
let dat = trees.selectAll().data(d3.range(n)).enter();
dat.append('rect').attrs(i=>({x:(i-1/2)*w,y:H,width:w,height:36,fill:dback,'stroke-width':2,stroke:dbord}));
dat.append('text').attrs(i=>({x:i*w,y:H+30,fill:dtext})).text(i=>i+1);

svg.append('path')
    .attr('d', 'M'+10.1*w+' '+H/2+'h80v-30l70 60l-70 60v-30h-80')
    .attrs({fill:'#c9e4f1', 'stroke-width':5, stroke:'#858693'});
